ALTER PROCEDURE [dbo].[P_ORDER_ADD_BONUS](@OrderKey int=null, -- 
@PhoneKey int=null,		--    
@AUTO_POINTS_ADD bit=1	--   
)
AS
BEGIN
-- =============================================
-- Author:		<Alexey Ivakhin>
-- Create date: <13.11.2015>
-- Update date: <07.11.2018>
-- Description:	<      : VIP, , >
-- =============================================
IF @OrderKey IS NULL OR @PhoneKey IS NULL return;
SET DATEFORMAT dmy;
DECLARE @VipKey int=null,@CardKey int=null,@LngMain varchar(2), @Price money, @PriceFull money,@TmpPrice money;
DECLARE @isEnabledDiscountSimpleVIP bit, @isEnabledDiscountSimpleCards bit,
@isEnabledDiscountAccumulatedPhone bit, @isEnabledDiscountAccumulatedVIP bit,@isEnabledDiscountPhonePoints bit,
@LimitFixed_ money, @LimitFixedLow_ int, @LimitPercent float,@Factor float, @Sum money, @ResPoints float;
SELECT TOP 1 @LngMain=LngMain FROM PROPERTIES;
	--  VIP
	SELECT TOP 1 @VipKey=PV.VIPKey FROM PhoneVIPs PV WHERE PV.PhoneKey=@PhoneKey;
	IF @VipKey IS NOT NULL UPDATE BASE SET vip=@VipKey WHERE UNIKEY=@OrderKey;
	SELECT @Price=Price, @PriceFull=PriceFull FROM BASE WITH(readpast) WHERE UNIKEY=@OrderKey;
	
	--   
	SELECT TOP 1 @CardKey=PL.CardKey FROM PhoneCardsLink PL WHERE PL.PhoneKey=@PhoneKey;
	IF @CardKey IS NOT NULL 
		INSERT INTO CardOrderLink ([Card],[Order],[sum]) VALUES (@CardKey,@OrderKey,0);
	
	-- ,     1  
		SELECT TOP 1 @isEnabledDiscountSimpleVIP=isAddToOrderAuto FROM DiscountSourceType DST WHERE UniKey=1 AND Lng LIKE @LngMain;
		SELECT TOP 1 @isEnabledDiscountSimpleCards=isAddToOrderAuto FROM DiscountSourceType DST WHERE UniKey=2 AND Lng LIKE @LngMain;
		SELECT TOP 1 @isEnabledDiscountAccumulatedPhone=isAddToOrderAuto FROM DiscountSourceType DST WHERE UniKey=3 AND Lng LIKE @LngMain;
		SELECT TOP 1 @isEnabledDiscountAccumulatedVIP=isAddToOrderAuto FROM DiscountSourceType DST WHERE UniKey=4 AND Lng LIKE @LngMain;
		SELECT TOP 1 @isEnabledDiscountPhonePoints=isAddToOrder FROM DiscountSourceType DST WHERE UniKey=6 AND Lng LIKE @LngMain;

		--    VIP 
		if @isEnabledDiscountSimpleVIP=1
			begin
			insert DiscountOrders (DiscountType,DiscountValue,DiscountValueType,Limit,SourceDetailKey,SourceKey,SourceType,OrderKey)
				SELECT DiscountType,DiscountValue,DiscountValueType,  LimitFixed,VR.UniKey, @VipKey, 1, @OrderKey 
				FROM VipDiscountRegular VR WHERE VIPKey=@VipKey AND DateBegin<=GETDATE() AND (DateEnd IS NULL OR DateEnd>=GETDATE())
					AND NOT EXISTS (SELECT 1 FROM DiscountOrders DO WHERE DO.OrderKey=@OrderKey AND DO.DiscountType=VR.DiscountType AND
						DO.DiscountValueType=VR.DiscountValueType);
			end;
		--     
		if @isEnabledDiscountSimpleCards=1
			begin
			insert DiscountOrders (DiscountType,DiscountValue,DiscountValueType,Limit,SourceDetailKey,SourceKey,SourceType,OrderKey)
				SELECT DiscountType,DiscountValue,DiscountValueType,  LimitFixed,VR.UniKey, @CardKey, 2, @OrderKey 
				FROM CardsDiscountRegular VR WHERE CardKey=@CardKey AND DateBegin<=GETDATE() AND (DateEnd IS NULL OR DateEnd>=GETDATE())
					AND NOT EXISTS (SELECT 1 FROM DiscountOrders DO WHERE DO.OrderKey=@OrderKey AND DO.DiscountType=VR.DiscountType AND
						DO.DiscountValueType=VR.DiscountValueType);
			end;
	/*     VIP*/
		if @isEnabledDiscountAccumulatedVIP=1
		begin
			insert DiscountOrders (DiscountType,DiscountValue,DiscountValueType,Limit,SourceDetailKey,SourceKey,SourceType,OrderKey)
				SELECT DiscountType,DiscountValue,DiscountValueType,  LimitFixed,VD.Discount, VD.UniKey, 4, @OrderKey 
					FROM DiscountsCumulativeValues DV 
				  LEFT JOIN VipDiscount VD ON VD.Discount=DV.DiscountsCumulativeKey
				  WHERE VD.VIP=@VipKey AND VD.Zakaz IS NULL AND VD.isEnabled=1  AND DV.DiscountValue!=0 AND DateBegin<=GETDATE() AND (DateEnd IS NULL OR DateEnd>=GETDATE())
					AND NOT EXISTS (SELECT 1 FROM DiscountOrders DO WHERE DO.OrderKey=@OrderKey AND DO.DiscountType=DV.DiscountType AND
						DO.DiscountValueType=Dv.DiscountValueType);
			--,    ""   
			UPDATE VipDiscount SET Zakaz=@OrderKey WHERE UniKey IN (SELECT DO.SourceKey FROM DiscountOrders DO WHERE DO.OrderKey=@OrderKey AND DO.SourceType=4);
		end;
	/*      */
		if @isEnabledDiscountAccumulatedPhone=1
		begin
		insert DiscountOrders (DiscountType,DiscountValue,DiscountValueType,Limit,SourceDetailKey,SourceKey,SourceType,OrderKey)
			SELECT DiscountType,DiscountValue,DiscountValueType,  LimitFixed,VD.Discount, VD.UniKey, 3, @OrderKey 
				  FROM DiscountsCumulativeValues DV 
				  LEFT JOIN PhoneDiscount VD ON VD.Discount=DV.DiscountsCumulativeKey
				  WHERE VD.PhoneKey=@PhoneKey AND VD.Zakaz IS NULL AND isEnabled=1 AND DV.DiscountValue!=0 AND DateBegin<=GETDATE() AND (DateEnd IS NULL OR DateEnd>=GETDATE())
					AND NOT EXISTS (SELECT 1 FROM DiscountOrders DO WHERE DO.OrderKey=@OrderKey AND DO.DiscountType=DV.DiscountType AND
						DO.DiscountValueType=Dv.DiscountValueType);
			--,    ""   
			UPDATE PhoneDiscount SET Zakaz=@OrderKey WHERE UniKey IN (SELECT DO.SourceKey FROM DiscountOrders DO WHERE DO.OrderKey=@OrderKey AND DO.SourceType=3);
		end;
	/*     */
		if (@isEnabledDiscountPhonePoints=1) AND (@PhoneKey IS NOT NULL) AND (@AUTO_POINTS_ADD=1)
		begin
		SET @Sum=NULL;
		SELECT @Sum=BL.PiramidePoints FROM BLACKLISTTEL BL WHERE BL.UniKey=@PhoneKey;
		IF ISNULL(@Sum,0)>0
			begin
			SET @LimitFixed_=0;
			SET @LimitFixedLow_=0;
			SET @LimitPercent=0;
			SET @Factor=0;
			EXEC [P_PIRAMIDE_CLIENTS_WRITEOFF_CONDITIONS_GET_ORDER] @OrderKey=@OrderKey, 
				@LimitFixed=@LimitFixed_ OUTPUT,@LimitPercent=@LimitPercent OUTPUT,
				@Factor=@Factor OUTPUT, @LimitFixedLow=@LimitFixedLow_ OUTPUT;
			SET @Factor=ISNULL(@Factor,1);
			--  
			IF @PriceFull!=0 				SET @TmpPrice=@PriceFull
				ELSE SET @TmpPrice=@Price;
			--          
			SET @ResPoints=0;
			IF @TmpPrice!=0 
				begin
				IF (@Sum*@Factor)>@TmpPrice SET @ResPoints=@TmpPrice/@Factor;
					else SET @ResPoints=@Sum;
				if @LimitFixed_>0 AND (@ResPoints>@LimitFixed_) SET @ResPoints=@LimitFixed_;
				IF @LimitPercent>0 AND (@LimitPercent*@TmpPrice/100)<(@ResPoints*@Factor)
					SET @ResPoints=(@LimitPercent*@TmpPrice/100)/@Factor;
				--      
				IF @LimitFixedLow_>@ResPoints SET @ResPoints=0;
				end;
			--print '@LimitFixed ='+CAST(@LimitFixed_ as varchar(16));
			--print '@ResPoints ='+CAST(@ResPoints as varchar(16));
			if @ResPoints!=0
				begin
				insert DiscountOrders (DiscountType,DiscountValue,DiscountValueType,Limit,SourceDetailKey,SourceKey,
						SourceType,OrderKey,LimitPercent,Factor,DiscountSum)
					VALUES(1,@ResPoints,3,@LimitFixed_,NULL,@PhoneKey,6,@OrderKey,@LimitPercent,@Factor,@ResPoints*@Factor);
				--   
				EXEC [P_PIRAMIDE_CLIENTS_POINTS] @R=2,@DiscountSourceType=6,@AbstractKey=@PhoneKey,
					@VALUE=@ResPoints,@UserKey=NULL,@DbKr=2,@Comment=NULL,@OrderKey=@OrderKey;
				end;
			end;		
		end;
	SET @VipKey=0;			
	SELECT @VipKey=COUNT(*) FROM DiscountOrders WHERE OrderKey=@OrderKey;
	IF ISNULL(@VipKey,0)>0 
		begin
		-- 
		--  
		IF @Price!=0 AND @PriceFull=0 
			begin
			SET @PriceFull=@Price;
			SET @Price=[dbo].[GetZakazDiscount](@OrderKey,@Price);
			end;
		UPDATE BASE SET isDiscount=1,Price=@Price, PriceFull=@PriceFull WHERE UNIKEY=@OrderKey;
		end;
END
GO
UPDATE DBVER SET FIX=1 WHERE PROGRAMNAME LIKE 'otaxi' AND DBVER LIKE '2.18.11.0';
GO